/****************************************************************************
**
** Copyright (C) 2011 Digia Plc
** All rights reserved.
** For any questions to Digia, please use contact form at http://qt.digia.com
**
** This file is part of the examples of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Digia nor the names of its contributors
**     may be used to endorse or promote products derived from this 
**     software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
** $QT_END_LICENSE$
** 
** Copyright (c) 2011 Nokia Corporation and/or its subsidiary(-ies).
**
****************************************************************************/

#include <QtGui>

#include "mysortfilterproxymodel.h"

//
// <<<< MySortFilterProxyModel::MySortFilterProxyModel
//
MySortFilterProxyModel::MySortFilterProxyModel(QObject *parent)
    : QSortFilterProxyModel(parent)
{
}
// >>>> MySortFilterProxyModel::MySortFilterProxyModel


//
// <<<< MySortFilterProxyModel::setFilterMinimumDate
//
void MySortFilterProxyModel::setFilterMinimumDate(const QDate &date)
{
    _minDate = date;
    invalidateFilter();
}
// >>>> MySortFilterProxyModel::setFilterMinimumDate


//
// <<<< MySortFilterProxyModel::setFilterMaximumDate
//
void MySortFilterProxyModel::setFilterMaximumDate(const QDate &date)
{
    _maxDate = date;
    invalidateFilter();
}
// >>>> MySortFilterProxyModel::setFilterMaximumDate


//
// <<<< MySortFilterProxyModel::filterAcceptsRow
//
bool MySortFilterProxyModel::filterAcceptsRow(int sourceRow
        , const QModelIndex &sourceParent) const
{
    QModelIndex index0 = sourceModel()->index(sourceRow, 0, sourceParent);
    QModelIndex index1 = sourceModel()->index(sourceRow, 1, sourceParent);
    QModelIndex index2 = sourceModel()->index(sourceRow, 2, sourceParent);

    return ( sourceModel()->data(index0).toString().contains(filterRegExp())
          || sourceModel()->data(index1).toString().contains(filterRegExp()))
          && dateInRange(sourceModel()->data(index2).toDate());
}
// >>>> MySortFilterProxyModel::filterAcceptsRow

//
// <<<< MySortFilterProxyModel::lessThan
//
bool MySortFilterProxyModel::lessThan(const QModelIndex &left,
                                      const QModelIndex &right) const
{
    QVariant leftData = sourceModel()->data(left);
    QVariant rightData = sourceModel()->data(right);

    if (leftData.type() == QVariant::DateTime) {
        return leftData.toDateTime() < rightData.toDateTime();
    } else {
        QRegExp *emailPattern = new QRegExp("([\\w\\.]*@[\\w\\.]*)");

        QString leftString = leftData.toString();
        if(left.column() == 1 && emailPattern->indexIn(leftString) != -1)
            leftString = emailPattern->cap(1);

        QString rightString = rightData.toString();
        if(right.column() == 1 && emailPattern->indexIn(rightString) != -1)
            rightString = emailPattern->cap(1);

        return QString::localeAwareCompare(leftString, rightString) < 0;
    }
}
// >>>> MySortFilterProxyModel::lessThan


//
// <<<< MySortFilterProxyModel::dateInRange
//
bool MySortFilterProxyModel::dateInRange(const QDate &date) const
{
    return ( ! _minDate.isValid() || date > _minDate )
        && ( ! _maxDate.isValid() || date < _maxDate );
}
// >>>> MySortFilterProxyModel::dateInRange
